package com.gic.haoban.manage.web.qo.wechatwork;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author guojx
 * @Date 2024/5/22 9:27
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WechatWorkLostStoreGroupQO extends StoreGroupCommonQO implements Serializable {
    /**
     * 开始日期, 非日类型的时候。根据数据组api文档
     */
    private String startDate;

    /**
     * 结束日期, 非日类型的时候。根据数据组api文档
     */
    private String endDate;

    /**
     * 排序类型 1 正序  2 倒序
     */
    private Integer orderByType;

    /**
     * 排序字段名称
     */
    private String orderByFields;

    private Integer pageNum;

    private Integer pageSize;


    /**
     * 下载导出参数：数据脱敏 1:脱敏 2:完整
     */
    private Integer dataType = 1;

    /**
     * 下载导出参数：为了兼容前端传参
     */
    private String requestProject;

    public Integer getDataApiOrderField() {
        Map<String, Integer> map = new HashMap<>(8);
        map.put("onewayFriendNum", 1);
        map.put("totalLostNum", 2);
        map.put("deleteSalesNum", 3);
        map.put("salesDeleteNum", 4);
        map.put("delIsSingleNum",5) ;
        return map.get(orderByFields) == null ? 1 : map.get(orderByFields);
    }

    public void dealWithParam(JSONObject jsonObject) {
        if (jsonObject == null) {
            jsonObject = new JSONObject();
        }
        if (StringUtils.isNotBlank(startDate)) {
            jsonObject.put("startDate", startDate);
        }
        if (StringUtils.isNotBlank(endDate)) {
            jsonObject.put("endDate", endDate);
        }
        if (orderByType != null) {
            jsonObject.put("orderByType", orderByType);
        }
        if (orderByFields != null) {
            jsonObject.put("orderByFields", getDataApiOrderField());
        }
        jsonObject.put("pageNum", pageNum);
        jsonObject.put("pageSize", pageSize);
    }
}
